"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FetchService = void 0;
const common_1 = require("@nestjs/common");
const fetch_constants_1 = require("./fetch.constants");
let FetchService = class FetchService {
    constructor(defaults = {}) {
        this.defaults = defaults;
    }
    request(request) {
        return fetch(request);
    }
    createRequest(url, options) {
        const { baseUrl, ...init } = { ...this.defaults, ...options };
        return new Request(new URL(url, baseUrl), init);
    }
    get(url, options = {}) {
        const request = this.createRequest(url, { ...options, method: 'GET' });
        return this.request(request);
    }
    head(url, options = {}) {
        const request = this.createRequest(url, { ...options, method: 'HEAD' });
        return this.request(request);
    }
    delete(url, options = {}) {
        const request = this.createRequest(url, { ...options, method: 'DELETE' });
        return this.request(request);
    }
    patch(url, options = {}) {
        const request = this.createRequest(url, { ...options, method: 'PATCH' });
        return this.request(request);
    }
    put(url, options = {}) {
        const request = this.createRequest(url, { ...options, method: 'PUT' });
        return this.request(request);
    }
    post(url, options = {}) {
        const request = this.createRequest(url, { ...options, method: 'POST' });
        return this.request(request);
    }
};
exports.FetchService = FetchService;
exports.FetchService = FetchService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(fetch_constants_1.FETCH_MODULE_OPTIONS)),
    __metadata("design:paramtypes", [Object])
], FetchService);
